import org.opencv.core.*;
import org.opencv.core.Point;
import org.opencv.highgui.HighGui;
import org.opencv.imgcodecs.Imgcodecs;
import org.opencv.imgproc.Imgproc;
import org.opencv.photo.Photo;
import static org.opencv.imgcodecs.Imgcodecs.imwrite;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.util.ArrayList;
import javax.imageio.ImageIO;

//REFERENCES:
//https://docs.opencv.org/3.4.3/d9/db0/tutorial_hough_lines.
//https://stackoverflow.com/questions/43443309/count-red-pixel-in-a-given-image
//https://www.wikihow.com/Calculate-Percentage-in-Java
//https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object



//GOAL for 21st


//Classifier 01
//Have args so can call "java image-identification-classifier01 XX XX"
//args can be parameters in algorthim such as threshold or theta?
//Run on 5000 images.
//Record success rates
//All done with makefile


//But first understand houghline transform
//Know what the algorithm being used is doing.
//MAke constants for this classifier
//Make java be able to run on CMD line

public class Main {

    static class StartAndEndPoint {
        //PRIVATES
        private Point _p1;
        private Point _p2;
        //CONSTRUCTOR
        public StartAndEndPoint(Point p1, Point p2){
            _p1 = p1;
            _p2 = p2;
        }
        //GETTERS
        public Point getP1(){
            return _p1;
        }
        public Point getP2(){
            return  _p2;
        }
        //SETTERS
        public void setP1(Point p1){
            _p1 = p1;
        }
        public void setP2(Point p2){
            _p2 = p2;
        }
    }

    //GLOBAL_CONSTANTS
    static int CLASSIFIER_HOUGHLINESP_MIN 	= 10;
    static int CLASSIFIER_HOUGHLINESP_MAX 	= 65;
    static int HOUGHLINEP_THRESHOLD			= 10;
    static int MINLINECOUNT                 = 40;
    static double MAXLINEGAP              	= 1;  //4
    static double SLOPEGRADIENT			  	= 0.02;
    //SHOULD TURN INTO ARGS

    private static  BufferedImage toBufferedImage(Mat mat){
        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
        try{
            int type = BufferedImage.TYPE_3BYTE_BGR;
            int bufferSize = mat.channels() * mat.cols() * mat.rows();
            byte[] b = new byte[bufferSize];
            //get all the pixels
            mat.get(0, 0, b);
            BufferedImage image = new BufferedImage(mat.cols(), mat.rows(), type);
            final byte[] targetPixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
            System.arraycopy(b, 0, targetPixels, 0, b.length);
            return image;
        }
        catch(Exception e){
            System.err.println(e);
        }
        return null;
    }
    private static boolean ClassifierPixelCount(BufferedImage img){
        try {
            //Read file
            //BufferedImage img = ImageIO.read(new File(processedFile));
            int x = img.getWidth();
            int y = img.getHeight();
            int pixelCount  = 0;
            int redCount    = 0;
            float percentage = 0;

            //Go Thru every pixel
            for(int i=0; i < y; i++){
                for(int j=0;j < x; j++){
                    //Get value for current pixels RGB value
                    int currPixelRGB = img.getRGB(j, i);
                    //Check if pixel is red (hex value of red)
                    if(currPixelRGB == 0xFFFF0000){
                        redCount++;
                    }
                    pixelCount++;
                }
            }
            //Calculate percentage of Red in image
            percentage = ((float)redCount/(float)pixelCount)*(float)100;
            //If more than %10 and less than %50 then its sheet music!
            if(percentage > CLASSIFIER_HOUGHLINESP_MIN && percentage < CLASSIFIER_HOUGHLINESP_MAX){ //MAKE THESE CONSTANTS!!
                return true;}
        }
        catch (Exception e) {
            System.err.println(e);
        }
        return false;
    }
    private static boolean ClassifierLineCount(int lineCount){

           if(lineCount>MINLINECOUNT){
                return true;
            }
            else{
                return false;
            }
    }
    private static ArrayList ClassifierLineClusterOLD(BufferedImage img){
        ArrayList returnArray = new ArrayList();
        try {

            //IF THIS WORKS THEN IMPLEMENT A VERSION THAT USES POINTS from the draw line code.
            //ALSO CHECK OUT K NEAREST NEIGHBOR?
            //0xFFFF0000 = RED

            //go thru every pixel until find red pixel
            //get y pos of red pixel
            //continue with loop until find another red pixel
            //get y pos of red pixel
            //compare y pos (if close together then continue loop) else break

            int x = img.getWidth();
            int y = img.getHeight();
            int closeLineCount = 0;
            ArrayList<Integer> redPixelYpos = new ArrayList<Integer>();



            //Go Thru every pixel
            for(int i=0; i < y; i++){
                for(int j=0;j < x; j++){
                    //Get value for current pixels RGB value
                    int currPixelRGB = img.getRGB(j, i);
                    //Check if pixel is red (hex value of red)
                    if(currPixelRGB == 0xFFFF0000) {

                        //Store y pos of red pixel if there is no duplicate
                        if(!redPixelYpos.contains(i)){
                            redPixelYpos.add(i);
                            //System.out.println(i );
                        }
                    }
                }
            }
            //Check if any of the lines found are close together and that there has been more than one line found
            if(redPixelYpos.size()>1){
                //go through list and compare every value
                for(int i =0; i< redPixelYpos.size(); i++){
                    for(int j=0; j< redPixelYpos.size(); j++){
                        //Check if difference is less than 4 and the values are not duplicates.
                        if(Math.abs(redPixelYpos.get(i) - redPixelYpos.get(j)) < 4 && !redPixelYpos.get(j).equals(redPixelYpos.get(i))){
                            closeLineCount++;
                        }
                    }
                }
            }
            int clusterCount = closeLineCount/4;

            if(closeLineCount >= 4){
                returnArray.add(true);
                returnArray.add(closeLineCount);
                returnArray.add(clusterCount);
            }
            else{
                returnArray.add(false);
                returnArray.add(closeLineCount);
                returnArray.add(clusterCount);
            }
        }
        catch (Exception e) {
            System.err.println(e);
        }
    return returnArray;
    }
    private static ArrayList ClassifierLineCluster(ArrayList<StartAndEndPoint> linePoints){
        ArrayList returnArray = new ArrayList();
        try {

            //SETUP RETURN ARRAY
            /*
            if(closeLineCount >= 4){
                returnArray.add(true);
                returnArray.add(closeLineCount);
                returnArray.add(clusterCount);
            }
            else{
                returnArray.add(false);
                returnArray.add(closeLineCount);
                returnArray.add(clusterCount);
            } */
        }
        catch (Exception e) {
            System.err.println(e);
        }
        return returnArray;
    }


    public static void main(String[] args) {

        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);

        try {
            //temp array for terminalversion

            ArrayList returnArray = new ArrayList();
            returnArray.add(true);
            returnArray.add(10);

            ArrayList<StartAndEndPoint> pointArrayList = new ArrayList();


            //Variables
            Mat edgesDetected = new Mat();
            Mat edgesDetectedRGB = new Mat();
            Mat edgesExtra = new Mat();
            Mat edgesDetectedRGBProb;
            Mat edgeDoesntMakeSense;
            Mat justEdges; //TESTING

            String directory = "/Scratch/cpb16/is-sheet-music-encore/download-images/MU/";
            //!!!!!!!!!!!!!!!!!!!!!!!!!!!NOT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //mdp.39015097852365-2.png 176 lines    Contents page.
            //mdp.39015097852555-3.png 76  lines
            String default_file = directory+"SheetMusic/coo.31924062612282-9.png";
            //String default_file ="TestImages/NotNot/mdp.39015080972303-3.png";


            //System.out.println(default_file);
            //String default_file = "TestImages/NotSheetMusic01.png";
            //String default_file = "TestImages/NotSheetMusic02.png";
            //String default_file = "TestImages/SheetMusic01.png";
            //String default_file = "TestImages/SheetMusic02.png";
            //String default_file = "TestImages/vLine.png";
            String filename = ((args.length > 0) ? args[0] : default_file);
            File file = new File(filename);
            if(!file.exists()){System.err.println("Image not found: "+ filename);}

            int horizontalLineCount =0;

            // Load an image
            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
            // Edge detection
            //01 CANNY
            //Imgproc.Canny(original, edgesDetected, 50, 200, 3, false);
            //Imgproc.Canny(original, edgesDetected,0, 100, 3, false );
            //Imgproc.Canny(original, edgesDetected,80, 120);
            //02 BINARYINV
            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, 4);

            //Imgproc.adaptiveThreshold(original, edgesExtra,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV,15, 4);
            //Imgproc.blur(edgesExtra, edgesDetected, new Size(3,1));
            //03 BINARY
            //Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY,15, 2);
            //04 NO PROC
            //edgesDetected = original.clone();
            //05 OTSU THRESHOLD
            //Imgproc.threshold(original, edgesDetected,0,255,Imgproc.THRESH_BINARY_INV+Imgproc.THRESH_OTSU);





            //Convert to RGB for future use
            Imgproc.cvtColor(edgesDetected, edgesDetectedRGB, Imgproc.COLOR_GRAY2BGR);
            justEdges = edgesDetectedRGB.clone();//TESTING
            edgesDetectedRGBProb = edgesDetectedRGB.clone();
            edgeDoesntMakeSense = edgesDetectedRGB.clone();

            Mat linesP = new Mat(); // will hold the results of the detection
            //(edgeDetectedImage, outputOfDetection(r,θ), resolution of rho, resolution of theta, threshold (minimum num of intersections)

            double minLineLength = edgesDetectedRGB.size().width/8;

            Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 720, HOUGHLINEP_THRESHOLD, minLineLength,MAXLINEGAP); // runs the actual detection
            //Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 180, HOUGHLINEP_THRESHOLD, minLineLength,MAXLINEGAP); // runs the actual detection
            System.out.println("Before Graident Filtering num lines: " + linesP.rows());

            //Imgproc.HoughLinesP(edgesDetected,linesP,1,Math.PI/2, 50, 80, 5);
            // Draw the lines
            for (int x = 0; x < linesP.rows(); x++) {
                double[] l = linesP.get(x, 0);

                //Find angle that line is at
                //double rho = linesP.get(x, 0)[0];
                //double theta = linesP.get(x, 0)[1];
                //double cosTheta = Math.cos(theta);
                //double sinTheta = Math.sin(theta);
                //double x0 = cosTheta * rho;
                //double y0 = sinTheta * rho;
                //double xpt1 = x0 + 1000 * (-sinTheta);
                //double ypt1 = y0 + 1000 * (cosTheta);
                //double xpt2 = x0 - 1000 * (-sinTheta);
                //double ypt2 = y0 - 1000 * (cosTheta);
                //double angle =  Math.atan2((float)ypt2 - (float)ypt1, (float)xpt2 - (float)xpt1)*(Math.PI);
                //double testAngle = (ypt2 - ypt1)/(xpt2 - xpt1);

                //New angles
                Point p1 = new Point(l[0], l[1]);
                Point p2 = new Point(l[2], l[3]);
                double m = Math.abs(p2.y - p1.y)/(p2.x - p1.x);

                if(m<=SLOPEGRADIENT) {
                    //System.out.println("m: " + m);
                    Imgproc.line(edgesDetectedRGB, p1, p2, new Scalar(0, 0, 255), 1, Imgproc.LINE_4, 0);
                    horizontalLineCount++;
                    pointArrayList.add(new StartAndEndPoint(p1, p2));
                }

            }
            //Point is a co ordinate (x, y)
            //Prove by finding number of points from one end to other:
            //Get width of image.
            System.out.println("every matrix widths: "+edgesDetectedRGB.size().width);
            File filenameTest = new File("TestImages/NotSheetMusic02.png");
            BufferedImage i = ImageIO.read(filenameTest);
            System.out.println("input image width: "+ i.getWidth());

            BufferedImage toBeClassifiedImg = toBufferedImage(edgesDetectedRGB);

            System.out.println("LINE COUNT RESULT:   " +  ClassifierLineCount(horizontalLineCount) + '\t' +"LineCount: " + horizontalLineCount); //COUNT OF LINES CLASSIFICATION
            System.out.println("LINE CLUSTER RESULT: " +  ClassifierLineClusterOLD(toBeClassifiedImg).get(0) + '\t' + "LinesFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(1) + '\t' + "ClustersFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(2));
            System.out.println("TESTER: " + ClassifierLineCluster(pointArrayList));

            System.out.println();
            //Display Results
            HighGui.imshow("Source", original);
            //HighGui.imshow("Just Edges", justEdges); //TESTING
            HighGui.imshow("Detected Lines (in red) - positive", edgesDetectedRGB);
            //HighGui.imshow("Detected Lines (in red) - negative", edgesDetectedRGBProb);
            //HighGui.imshow("Detected Lines (in red) - edgeDoesntMakeSense", edgeDoesntMakeSense);

            // Wait and Exit
            HighGui.waitKey();
            System.exit(0);
        }
        catch(Exception e){
            System.err.println(e);
        }
    }
}
